QuantLib: Index Class Reference

A free/open-source library for quantitative finance Reference manual - version 1.20

Public Member Functions | List of all members
Index Class Referenceabstract

purely virtual base class for indexes More...

`#include <ql/index.hpp>`

Inheritance diagram for Index:
[legend]

## Public Member Functions
virtual std::string | name () const =0
| Returns the name of the index. More...
virtual Calendar | fixingCalendar () const =0
| returns the calendar defining valid fixing dates
virtual bool | isValidFixingDate (const Date &fixingDate) const =0
| returns TRUE if the fixing date is a valid one
virtual Real | fixing (const Date &fixingDate, bool forecastTodaysFixing=false) const =0
| returns the fixing at the given date More...
const TimeSeries< Real > & | timeSeries () const
| returns the fixing TimeSeries
virtual bool | allowsNativeFixings ()
| check if index allows for native fixings. More...
virtual void | addFixing (const Date &fixingDate, Real fixing, bool forceOverwrite=false)
| stores the historical fixing at the given date More...
void | addFixings (const TimeSeries< Real > &t, bool forceOverwrite=false)
| stores historical fixings from a TimeSeries More...
template<class DateIterator , class ValueIterator >
void | addFixings (DateIterator dBegin, DateIterator dEnd, ValueIterator vBegin, bool forceOverwrite=false)
| stores historical fixings at the given dates More...
void | clearFixings ()
| clears all stored historical fixings
Public Member Functions inherited from Observable
| Observable (const Observable &)
Observable & | operator= (const Observable &)
void | notifyObservers ()

## Detailed Description

purely virtual base class for indexes

Warning:
  this class performs no check that the provided/requested fixings are for dates in the past, i.e. for dates less than or equal to the evaluation date. It is up to the client code to take care of possible inconsistencies due to "seeing in the future"

## Member Function Documentation

## ◆ name()

virtual std::string name | ( |  | ) | const
| pure virtual

Returns the name of the index.

Warning:
  This method is used for output and comparison between indexes. It is not meant to be used for writing switch-on-type code.

Implemented in InterestRateIndex, and InflationIndex.

## ◆ fixing()

virtual Real fixing | ( | const Date & | fixingDate,
|  | bool | forecastTodaysFixing = `false`
| ) |  | const
| pure virtual

returns the fixing at the given date

the date passed as arguments must be the actual calendar date of the fixing; no settlement days must be used.

Implemented in InflationIndex, InterestRateIndex, YoYInflationIndex, and ZeroInflationIndex.

## ◆ allowsNativeFixings()

virtual bool allowsNativeFixings | ( |  | ) |
| virtual

check if index allows for native fixings.

If this returns false, calls to addFixing and similar methods will raise an exception.

Reimplemented in SwapSpreadIndex.

## ◆ addFixing()

virtual void addFixing | ( | const Date & | fixingDate,
|  | Real | fixing,
|  | bool | forceOverwrite = `false`
| ) |  |
| virtual

stores the historical fixing at the given date

the date passed as arguments must be the actual calendar date of the fixing; no settlement days must be used.

Reimplemented in InflationIndex.

## ◆ addFixings() [1/2]

void addFixings | ( | const TimeSeries< Real > & | t,
|  | bool | forceOverwrite = `false`
| ) |  |

stores historical fixings from a TimeSeries

the dates in the TimeSeries must be the actual calendar dates of the fixings; no settlement days must be used.

## ◆ addFixings() [2/2]

void addFixings | ( | DateIterator | dBegin,
|  | DateIterator | dEnd,
|  | ValueIterator | vBegin,
|  | bool | forceOverwrite = `false`
| ) |  |

stores historical fixings at the given dates

the dates passed as arguments must be the actual calendar dates of the fixings; no settlement days must be used.